angular.module('starter.services', [])
.factory('JsonCache', function ($cacheFactory) {
            return $cacheFactory('JsonCache');
    })
.factory('Home', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, page){
      var deferred = $q.defer();
      var url = $rootScope.domain+'posts?page='+page;
      var array = [];
        

      if(flag)
      {
      $http.get(url).success(function(data){
 for(var i=0; i<data.length; i++)
{
    var temp = {};
    temp.id = data[i].id;
    temp.date = data[i].date;
    temp.title = data[i].title.rendered;
    var trim = data[i].excerpt.rendered;  
    temp.excerpt = trim.slice(0, 180);
    array.push(temp);  
  
    if(array.length == data.length)
      deferred.resolve(array); 
}

});       
      }
       else   
       {
      $http.get(url, { cache: JsonCache}).success(function(data){ 

for(var i=0; i<data.length; i++)
{
    var temp = {};
    temp.id = data[i].id;
    temp.date = data[i].date;
    temp.title = data[i].title.rendered;
    var trim = data[i].excerpt.rendered;  
    temp.excerpt = trim.slice(0, 180);
    array.push(temp);  
  
    if(array.length == data.length)
      deferred.resolve(array); 
} 

 });         
       }

return deferred.promise; 
    }}}])

.factory('PostNav', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(date, task){
      var deferred = $q.defer();
      var url;
        date = date.toString();
        if(task == 'p')
         url = $rootScope.domain+'posts?per_page=1&before='+date;
        else
         url = $rootScope.domain+'posts?per_page=1&order=asc&after='+date;  

      $http.get(url).success(function(data){ deferred.resolve(data); });

      return deferred.promise; 
    }}}])
  
.factory('Post', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, id){
      var deferred = $q.defer();
      var url = $rootScope.domain+'posts/'+id; 
   
  if(flag)
   $http.get(url).success(function(data){ deferred.resolve(data); });
  else   
   $http.get(url, { cache: JsonCache}).success(function(data){deferred.resolve(data); 
 }); 
return deferred.promise; 
    }}}])
  
.factory('Search', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { query: function(query){
      var deferred = $q.defer();
      var url = $rootScope.domain+'posts?search='+query+'&per_page=30';
      var array = [];

      $http.get(url).success(function(data){
 for(var i=0; i<data.length; i++)
{
    var temp = {};
    temp.id = data[i].id;
    temp.date = data[i].date;
    temp.title = data[i].title.rendered;
    var trim = data[i].excerpt.rendered;  
    temp.excerpt = trim.slice(0, 180);
    array.push(temp);  
  
    if(array.length == data.length)
      deferred.resolve(array); 
}

});       


return deferred.promise; 
    }}}]) 
  
.factory('Categories', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag){
      var deferred = $q.defer();
      var url = $rootScope.domain+'categories?orderby=count&order=desc&per_page=100'; 
   
  if(flag)
   $http.get(url).success(function(data){ deferred.resolve(data); });
  else   
   $http.get(url, { cache: JsonCache}).success(function(data){deferred.resolve(data); 
 }); 
return deferred.promise; 
    }}}]) 

.factory('CategoryName', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, id){
      var deferred = $q.defer();
      var url = $rootScope.domain+'categories/'+id; 
   
  if(flag)
   $http.get(url).success(function(data){ deferred.resolve(data); });
  else   
   $http.get(url, { cache: JsonCache}).success(function(data){deferred.resolve(data); 
 }); 
return deferred.promise; 
    }}}])

.factory('Author', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, id){
      var deferred = $q.defer();
      var url = $rootScope.domain+'users/'+id; 
   
  if(flag)
   $http.get(url).success(function(data){ deferred.resolve(data); });
  else   
   $http.get(url, { cache: JsonCache}).success(function(data){deferred.resolve(data); 
 }); 
return deferred.promise; 
    }}}])
  
.factory('AuthorPost', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, id, page){
      var deferred = $q.defer();
      var url = $rootScope.domain+'posts?author='+id+'&page='+page;
   var array = [];
    

      if(flag)
      $http.get(url).success(function(data){ 
   

for(var i=0; i<data.length; i++)
{
    var temp = {};
    temp.id = data[i].id;
    temp.date = data[i].date;
    temp.title = data[i].title.rendered;
    var trim = data[i].excerpt.rendered;  
    temp.excerpt = trim.slice(0, 180);
    array.push(temp);  
  
    if(array.length == data.length)
      deferred.resolve(array); 
}

});
       else   
      $http.get(url, { cache: JsonCache}).success(function(data){ 
   

for(var i=0; i<data.length; i++)
{
    var temp = {};
    temp.id = data[i].id;
    temp.date = data[i].date;
    temp.title = data[i].title.rendered;
    var trim = data[i].excerpt.rendered;  
    temp.excerpt = trim.slice(0, 180);
    array.push(temp);  
  
    if(array.length == data.length)
      deferred.resolve(array); 
} 

 });

return deferred.promise; 
    }}}]) 
  
.factory('Comments', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(id){
      var deferred = $q.defer();
      var url = $rootScope.domain+'comments?post='+id; 
   $http.get(url).success(function(data){ deferred.resolve(data); }); 
return deferred.promise; 
    }}}])
  
.factory('Category', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, id, page){
      var deferred = $q.defer();
      var url = $rootScope.domain+'posts?per_page=10&categories='+id+'&page='+page;
      var array = [];
 
   if(flag) 
   {
       $http.get(url).success(function(data){ 
            for(var i=0; i<data.length; i++)
            {
                var temp = {};
                temp.id = data[i].id;
                temp.date = data[i].date;
                temp.title = data[i].title.rendered;
                var trim = data[i].excerpt.rendered;  
                temp.excerpt = trim.slice(0, 180);
                array.push(temp);  
              
                if(array.length == data.length)
                  deferred.resolve(array); 
            } 
       });   
   }
   else
   {
       $http.get(url, { cache: JsonCache}).success(function(data){ 
                 for(var i=0; i<data.length; i++)
                {
                    var temp = {};
                    temp.id = data[i].id;
                    temp.date = data[i].date;
                    temp.title = data[i].title.rendered;
                    var trim = data[i].excerpt.rendered;  
                    temp.excerpt = trim.slice(0, 180);
                    array.push(temp);  
                  
                    if(array.length == data.length)
                      deferred.resolve(array); 
                } 
       });  
   }
    
return deferred.promise; 
    }}}])
  
.factory('Pages', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag){
      var deferred = $q.defer();
      var url = $rootScope.domain+'pages';
      var array = [];

   if(flag) 
   {
       $http.get(url).success(function(data){ 
            for(var i=0; i<data.length; i++)
            {
                var temp = {};
                temp.id = data[i].id;
                temp.date = data[i].date;
                temp.title = data[i].title.rendered;
                var trim = data[i].excerpt.rendered;  
                temp.excerpt = trim.slice(0, 180);
                array.push(temp);  
              
                if(array.length == data.length)
                  deferred.resolve(array); 
            } 
       });   
   }
   else
   {
       $http.get(url, { cache: JsonCache}).success(function(data){ 
                 for(var i=0; i<data.length; i++)
                {
                    var temp = {};
                    temp.id = data[i].id;
                    temp.date = data[i].date;
                    temp.title = data[i].title.rendered;
                    var trim = data[i].excerpt.rendered;  
                    temp.excerpt = trim.slice(0, 180);
                    array.push(temp);  
                  
                    if(array.length == data.length)
                      deferred.resolve(array); 
                } 
       });  
   }
    
return deferred.promise; 
    }}}])
  
.factory('Page', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag, id){
      var deferred = $q.defer();
      var url = $rootScope.domain+'pages/'+id;
      var array = [];

   if(flag) 
   {
       $http.get(url).success(function(data){  deferred.resolve(data); });   
   }
   else
   {
       $http.get(url, { cache: JsonCache}).success(function(data){ deferred.resolve(data); });  
   }
    
return deferred.promise; 
    }}}])

.factory('PageNav', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(date, task){
      var deferred = $q.defer();
      var url;
        date = date.toString();
        if(task == 'p')
         url = $rootScope.domain+'pages?per_page=1&before='+date;
        else
         url = $rootScope.domain+'pages?per_page=1&order=asc&after='+date;  

      $http.get(url).success(function(data){ deferred.resolve(data); });

      return deferred.promise; 
    }}}])
 
.factory('Authors', ['$http', '$q', '$rootScope', 'JsonCache', function($http, $q, $rootScope, JsonCache){
    return { get: function(flag){
      var deferred = $q.defer();
      var url = $rootScope.domain+'users?per_page=100';

      if(flag)
      $http.get(url).success(function(data){ deferred.resolve(data); });
      else
      $http.get(url, {cache: JsonCache})
             .success(function(data){ deferred.resolve(data); });
      return deferred.promise; 
    }}}])
 
.filter('to_trusted', ['$sce', function($sce){
        return function(text) {
            return $sce.trustAsHtml(text);
        };
}]);